<?php


function formulaires_telecharger_codes_postaux_charger()
{
    include_spip('codes_postaux_config');
    $tab_objet = codes_postaux_config_tab_fichier();
    foreach ($tab_objet as $key => &$objet) {
        //var_dump($fichier);
        if (is_array($objet['url_fichier'])) {
            $objet['url_fichier'] = implode(',', $objet['url_fichier']);
        }
        if (preg_match('`^http`i', $objet['url_fichier'])) {
            $objet = $objet;
        } else {
            unset($tab_objet[$key]);
        }
    }


    return array('tab_objet' => $tab_objet);
}


function formulaires_telecharger_codes_postaux_verifier_dist()
{
    include_spip('codes_postaux_config');
    include_spip('inc/config');
    $erreurs = array();
    $tab_objet = codes_postaux_config_tab_fichier();
    $emplacement = sous_repertoire(_DIR_TMP, 'codes_postaux');
    // login trop court ou existant
    if ($objet = _request('objet')) {
        if (!isset($tab_objet[$objet])) {
            $erreurs['objet'] = _T('codes_postaux:fichier_incorrect');
            $erreurs['message_erreur'] .= _T('codes_postaux:fichier_incorrect');
        }
    } else {
        $erreurs['objet'] = _T('codes_postaux:choix_erronne');

    }

    return $erreurs;
}

// https://code.spip.net/@inc_editer_mot_dist
function formulaires_telecharger_codes_postaux_traiter_dist()
{
    include_spip('codes_postaux_config');
    include_spip('inc/codes_postaux_import');
    include_spip('inc/config');
    $tab_objet = codes_postaux_config_tab_fichier();
    $objet = _request('objet');
    $tab_fichier_telecharger = array();
    $tab_fichier = codes_postaux_tab_fichier_telecharger($tab_objet[$objet]['url_fichier']);
    foreach ($tab_fichier as $fichier) {
        $nom_fichier_txt = "";
        if (isset($tab_objet[$objet]['nom_fichier'])) {
            $nom_fichier_txt = $tab_objet[$objet]['nom_fichier'];
        }
        $nom_fichier = codes_postaux_telecharger_fichier_distant($fichier, $nom_fichier_txt);
        if ($nom_fichier)
            $tab_fichier_telecharger[] = $nom_fichier;
    }

    $retour['editable'] = true;
    if (count($tab_fichier_telecharger) == count($tab_fichier)) {
        $retour['message_ok'] = _T('code_postal:telechargement_ok', array('objet' => $objet));
    } else {
        $retour['message_erreur'] = _T('code_postal:telechargement_erreur');
    }
    return $retour;

}


function codes_postaux_telecharger_fichier_distant($source, $nom_fichier_txt = "")
    {
        include_spip('inc/distant');
        include_spip('inc/config');

        $fichier = copie_locale($source, 'force');
        if (file_exists(_DIR_RACINE . $fichier)) {
            $infos_fichier = pathinfo($fichier);
            $emplacement = sous_repertoire(_DIR_TMP, 'codes_postaux');
            @chmod($emplacement, 0777);
            $nom_fichier = $emplacement . $infos_fichier['filename'] . '.' . $infos_fichier['extension'];

            if ($infos_fichier['extension'] === 'zip') {
                include_spip('inc/joindre_document');
                include_spip('inc/archives');
                $zip = new Spip\Archives\SpipArchives(_DIR_RACINE . $fichier);

                if (!$infos = $zip->informer()) {
                    spip_log(
                        'charger_decompresser erreur zip ' . $zip->erreur() . ' ' . $zip->message() . ' pour paquet: ' . $quoi['archive'],
                        'teleport' . _LOG_ERREUR
                    );
                    return $zip->message();
                }
                $target = _DIR_TMP;
                if (!$zip->deballer($target)) {
                    spip_log(
                        'charger_decompresser erreur tar ' . $zip->erreur() . ' ' . $zip->message() . ' pour paquet: ' . $quoi['archive'],
                        'teleport' . _LOG_ERREUR
                    );
                    return $zip->message();
                }


                if (isset($infos['fichiers'][0])) {
                    foreach ($infos['fichiers'] as $fichier) {
                        if ($fichier['filename'] !== "readme.txt"){
                            rename( _DIR_TMP.$fichier['filename'], $emplacement . $nom_fichier_txt);
                        }
                    }
                }
                unlink(_DIR_RACINE .$nom_fichier);
                return $nom_fichier;
            }
            else{
                rename(_DIR_RACINE . $nom_fichier, $emplacement.$nom_fichier_txt);
                return $nom_fichier;
            }

        }
        return false;
    }


